package app;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;

public class Reader3 {

    public void test0(String nazwa) throws FileNotFoundException {
        // Wczytuje słowa z pliku i wypisuje każde z nich w osobnym wierszu
        System.out.println("--- Test0 pliku " + nazwa + " ---");

        Scanner scanner = new Scanner(new File(nazwa));
        while (scanner.hasNext()) {
            System.out.println(scanner.next());
        }


        // scanner.forEachRemaining(System.out::println);
    }

    public void test1(String nazwa) throws FileNotFoundException {
        // Wczytuje słowa z pliku i wypisuje bez powtórzeń
        System.out.println("--- Test1 pliku " + nazwa + " ---");
        // Set<String> słowa = new HashSet<>(); // losowo
        // Set<String> słowa = new TreeSet<>(); // posortowane
        Set<String> słowa = new LinkedHashSet<>(); // w kolejności wstawiania
        Scanner scanner = new Scanner(new File(nazwa));
        scanner.forEachRemaining(słowa::add);
        słowa.forEach(System.out::println);


        // scanner.forEachRemaining(System.out::println);
    }

    public void test2(String nazwa) throws FileNotFoundException {
        // Wczytuje słowa z pliku i wypisuje bez powtórzeń, ale z numerami linii, w których dane słowo wystąpiło
        System.out.println("--- Test2 pliku " + nazwa + " ---");
        // Map<String, List<Integer>> słowa = new HashMap<>(); // losowo
        // Map<String, List<Integer>> słowa = new TreeMap<>(); // posortowane
        Map<String, List<Integer>> słowa = new LinkedHashMap<>(); // w kolejności wstawiania
        Scanner scanner = new Scanner(new File(nazwa));
        int index = 1;
        while(scanner.hasNextLine()){
            String line = scanner.nextLine();
            Scanner lineScanner = new Scanner(line);
            while(lineScanner.hasNext()){
                String word = lineScanner.next();
                if(!słowa.containsKey(word)){
                    słowa.put(word,new ArrayList<>());
                }
                słowa.get(word).add(index);
            }
            index++;
        }

        słowa.forEach((key, value) -> System.out.println(key + ": " + value));
    }
}
