package app.wildcards;

import app.antipattern.Singleton;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Map;

public class SimpleWildcard {

    public void iterate(Map<?, ?> map) {
        System.out.println(map.getClass());
        map.forEach((key, value) -> {
            System.out.println("*** key and value pair number: " + Singleton.getInstance().counter);
            System.out.println(key);
            System.out.println(value);
            System.out.println("key is of type " + key.getClass());
            System.out.println("value is of type " + value.getClass());
            System.out.println();
            Singleton.getInstance().counter++;
        });
    }

    public static void main(String[] args) {
        SimpleWildcard simpleWildcard = new SimpleWildcard();
        Singleton.getInstance().counter = 0;
        simpleWildcard.iterate(Map.of(
                "a", new ArrayList<Integer>(),
                "b", new LinkedList<Double>())
        );
        System.out.println("*** number of printed elements: " + Singleton.getInstance().counter);
    }
}
