package app.wildcards;

import java.util.Collection;

public class Writer {

    public static <T> T writeAllX(Collection<T> collection, Sink<T> sink) {
        T last = null;
        for (T t : collection) {
            last = t;
            sink.flush(last);
        }
        return last;
    }

    public static <T> T writeAllY(Collection<? extends T> collection, Sink<T> sink) {
        T last = null;
        for (T t : collection) {
            last = t;
            sink.flush(last);
        }
        return last;
    }

    public static <T> T writeAllZ(Collection<T> collection, Sink<? super T> sink) {
        T last = null;
        for (T t : collection) {
            last = t;
            sink.flush(last);
        }
        return last;
    }

    public static void doWork() {
        Sink<Object> sink = null;
        Collection<String> collection = null;
//        String string1 = Writer.writeAllX(collection, sink); // Illegal
        String string2 = (String) Writer.writeAllY(collection, sink); // Have to cast
        String string3 = Writer.writeAllZ(collection, sink);
    }
}
